#define USE_CUSTOM_HSV
#define DODEBUG
//#define DOBENCH
#include "mainwindow.h"
#include <QVBoxLayout>
#include <QResizeEvent>
#include <cmath>
#include <QtConcurrent/QtConcurrent>
#include <QFileDialog>
#include <QMessageBox>
#define to255(val)static_cast<int>((val)*255+0.5)
#ifdef DODEBUG
#include <QElapsedTimer>
#else
#endif
#define doprocessing v=newh.value()/100.0
#ifdef DOBENCH
#define BENCHES 700
unsigned times[BENCHES+1];
unsigned donebenches=0;
QFile file("bench.txt");
void dumpbench(QFile &file){
	for (unsigned i=0;i<BENCHES+1;i++)
		file.write((std::to_string(times[i])+'\n').c_str());
}
// void dumpavaragebench(QFile &file){
// 	float sum=0;
// 	for (unsigned i=0;i<BENCHES+1;i++)
// 		sum+=times[i];
// 	file.write(("Avarage: "+std::to_string(sum/BENCHES)+'\n').c_str());
// }
#define dumpbenches(file)dumpbench(file)//;dumpavaragebench(file)
#endif
#ifdef USE_CUSTOM_HSV
#define stuff
#else
#define stuff /360.0
#endif

char highestPowerOfTwo(char n) {
    if (n == 0) return 0;
    char res = 1;
    while (res << 1 <= n) {
        res <<= 1;
    }
    return res;
}
MainWindow::MainWindow(QWidget *parent)
    : QMainWindow(parent)
{
		QWidget *central = new QWidget(this);
		setCentralWidget(central);
    label.setScaledContents(true);
    label.setParent(central);
		openfilebtn.setText("Open file");
		savefilebtn.setText("Save file");
		QGridLayout *gridLayout = new QGridLayout;
		QLabel *x1l=new QLabel("x1:",central);
		gridLayout->addWidget(x1l, 1, 0);
		gridLayout->addWidget(&x1, 1, 1);
		QLabel *y1l=new QLabel("y1:",central);
		gridLayout->addWidget(y1l, 1, 2);
		gridLayout->addWidget(&y1, 1, 3);
		QLabel *x2l=new QLabel("x2:",central);
		gridLayout->addWidget(x2l, 2, 0);
		gridLayout->addWidget(&x2, 2, 1);
		QLabel *y2l=new QLabel("y2:",central);
		gridLayout->addWidget(y2l, 2, 2);
		gridLayout->addWidget(&y2, 2, 3);
		x1.setSingleStep(10);
		y1.setSingleStep(10);
		x2.setSingleStep(10);
		y2.setSingleStep(10);
		QLabel *hsl=new QLabel("HS:",central);
		gridLayout->addWidget(hsl, 3, 0);
		QLabel *hel=new QLabel("HE:",central);
		gridLayout->addWidget(hel, 3, 2);
		hstart.setRange(0, 360);
		hstart.setSuffix("°");
		gridLayout->addWidget(&hstart, 3, 1);
		hend.setRange(0, 360);
		hend.setSuffix("°");
		gridLayout->addWidget(&hend, 3, 3);
		hstart.setSingleStep(5);
		hend.setSingleStep(5);
		gridLayout->setAlignment(Qt::AlignTop | Qt::AlignLeft);
		central->setLayout(gridLayout);
		hstart.setValue(150);
		hend.setValue(210);
		gridLayout->addWidget(&openfilebtn, 0, 0, 1, 2);
		gridLayout->addWidget(&savefilebtn, 0, 2, 1, 2);
		connect(&x1, SIGNAL(valueChanged(int)), this, SLOT(calcthreadsandprocess()));
		connect(&y1, SIGNAL(valueChanged(int)), this, SLOT(calcthreadsandprocess()));
		connect(&x2, SIGNAL(valueChanged(int)), this, SLOT(calcthreadsandprocess()));
		connect(&y2, SIGNAL(valueChanged(int)), this, SLOT(calcthreadsandprocess()));
		connect(&newh, SIGNAL(valueChanged(int)), this, SLOT(processimage()));
		connect(&hstart, SIGNAL(valueChanged(int)), this, SLOT(hsc()));
		connect(&hend, SIGNAL(valueChanged(int)), this, SLOT(hec()));
		connect(&openfilebtn, SIGNAL(clicked()), this, SLOT(openfile()));
		connect(&savefilebtn, SIGNAL(clicked()), this, SLOT(savefile()));
		hcheck.setChecked(true);
		label.installEventFilter(this);
		QLabel *newhl=new QLabel("V=",central);
		gridLayout->addWidget(newhl, 4, 0);
		gridLayout->addWidget(&newh, 4, 1);
		newh.setRange(0, 100);
		newh.setSuffix("%");
		gridLayout->addWidget(&hcheck, 4, 2,1,2);
		hcheck.setText("Змінити");
		openfile();
		connect(&hcheck, SIGNAL(stateChanged(int)), this, SLOT(processimage()));
}

void MainWindow::resizeEvent(QResizeEvent *event)
{
#ifdef DODEBUG
    qDebug() << "Resize event:" << size();
#endif
    QSize imageSize = hsvImage.size();
    imageSize.scale(size(), Qt::KeepAspectRatio);
    
    if(size().height()*3 > hsvImage.height() && size().width()*3 > hsvImage.width()) {
        label.setPixmap(QPixmap::fromImage(hsvImage));
#ifdef DODEBUG
        qDebug() << "SmoothTransformation";
#endif
    } else {
        label.setPixmap(QPixmap::fromImage(hsvImage).scaled(imageSize, Qt::KeepAspectRatio, Qt::FastTransformation));
#ifdef DODEBUG
        qDebug() << "FastTransformation";
#endif
    }
    
    label.resize(imageSize);
    label.move((size().width()-imageSize.width())/2, (size().height()-imageSize.height())/2);
}

void MainWindow::processimage() {
#ifdef DOBENCH
	if(!donebenches)
	file.open(QIODevice::WriteOnly);
#endif
	bool convert=hcheck.isChecked();
	float start=hstart.value() stuff;
	float end=hend.value() stuff;
#if defined(DODEBUG) || defined(DOBENCH)
    QElapsedTimer timer;
#endif
		if (height){
		unsigned short xoffset=rgbImage.width()-x2.value();
		hsvImage = rgbImage.copy();
#if defined(DODEBUG) || defined(DOBENCH)
		timer.start();
#endif
    auto processBlock = [=](unsigned short blockIndex) {
        const unsigned short startY = blockIndex * blockSize+y1.value();
        #define /*const unsigned short*/ endY/* = (blockIndex==numThreads-1)?y2.value():*/startY+blockSize//;
				//if (endY+50>y2.value())qDebug() << "Processing block:" << blockIndex << "from" << startY << "to" << endY;
				
				QRgb *line = reinterpret_cast<QRgb *>(hsvImage.bits() + startY * rgbImage.bytesPerLine());
        for (unsigned short y = startY; y < endY; ++y) {
						line += x1.value();
						for (unsigned short x = x1.value(); x < x2.value(); ++x) {
                float h, s, v;
#ifdef USE_CUSTOM_HSV
								unsigned char *buf = reinterpret_cast<unsigned char*>(line);
								float b = *buf++/255.0;
								float g = *buf++/255.0;
								float r = *buf++/255.0;								
								v = std::fmax(r, std::fmax(g, b));
													float min = std::fmin(r, std::fmin(g, b));
													float delta = v - min;
								
													h = 0;
													if (delta != 0) {
															if (v == r) {
																	h = 60 * fmod((g - b) / delta, 6);
															} else if (v == g) {
																	h = 60 * ((b - r) / delta + 2);
															} else {
																	h = 60 * ((r - g) / delta + 4);
															}
													}
													if (h < 0) h += 360;
													s = (v == 0) ? 0 : delta / v;
#else
								QColor color = QColor::fromRgb(*line);
								color.getHsvF(&h, &s, &v);
#endif
                if(convert&&h>=start&&h<end)doprocessing;
#ifdef USE_CUSTOM_HSV
								#define c v*s
								float xh = c * (1 - std::fabs(fmod(h / 60.0, 2) - 1));
													float m = v - c;
								
													float r1 = 0, g1 = 0, b1 = 0;
													if (h < 60) {
															r1 = c; g1 = xh; b1 = 0;
													} else if (h < 120) {
															r1 = xh; g1 = c; b1 = 0;
													} else if (h < 180) {
															r1 = 0; g1 = c; b1 = xh;
													} else if (h < 240) {
															r1 = 0; g1 = xh; b1 = c;
													} else if (h < 300) {
															r1 = xh; g1 = 0; b1 = c;
													} else {
															r1 = c; g1 = 0; b1 = xh;
													}
								
													QColor finalColor(
																to255(r1+m),
																to255(g1+m),
																to255(b1+m)
													);
#else
                QColor finalColor = QColor::fromHsvF(h, s, v);
#endif
                *line = finalColor.rgb();
								line++;
            }
						line += xoffset;
        }
    };
    QList<QFuture<void>> futures;
    for (unsigned short i = 0; i < numThreads; ++i) {
        futures << QtConcurrent::run(processBlock, i);
    }
    for (auto &f : futures)
        f.waitForFinished();
		label.setPixmap(QPixmap::fromImage(hsvImage));
#ifdef DODEBUG
#ifdef DOCHECK
		bool same = true;
		unsigned wrong=0;
		if (!convert){
		for (int y = 0; y < rgbImage.height(); ++y)
				for (int x = 0; x < rgbImage.width(); ++x) {
						QColor original = rgbImage.pixelColor(x, y);
						QColor converted = hsvImage.pixelColor(x, y);
		
						if (original != converted) {
								same = false;
								wrong++;
								qDebug() << "Different pixel at (" << x << "," << y << "):"
												 << "original RGB(" << original.red() << "," << original.green() << "," << original.blue() << ")"
												 << "vs converted RGB(" << converted.red() << "," << converted.green() << "," << converted.blue() << ")";
						}
				}
		if (same)qDebug() << "Conversion check passed";else qDebug() << "Got wrong" << wrong;}
		else
			qDebug() << "conversion check skipped";
#endif
#endif
#ifdef DOBENCH
		if(donebenches==BENCHES+1){dumpbenches(file);file.close();exit(0);}else{times[donebenches]=timer.nsecsElapsed();donebenches++;}
		processimage();
#else
#ifdef DODEBUG
		qDebug() << "Processing time:" << timer.elapsed() << "ms with"<<numThreads<<"threads";
#endif
#endif
    }
}

void MainWindow::hsc(){
		if (hstart.value() > hend.value()) {
				hend.setValue(hstart.value());
		}
		processimage();
}
void MainWindow::hec(){
		if (hstart.value() > hend.value()) {
				hstart.setValue(hend.value());
		}
		processimage();
}
void MainWindow::openfile() {
    QFileDialog dialog(this);
    dialog.setFileMode(QFileDialog::ExistingFiles);
    dialog.setNameFilter(tr("Images (*.png *.jpg *.jpeg *.bmp *.webp *.tiff)"));
    dialog.setViewMode(QFileDialog::Detail);

    if (dialog.exec()) {
        QString filename = dialog.selectedFiles().first();
        if (!rgbImage.load(filename)) {
            QMessageBox::critical(this, tr("Помилка"), tr("Не вдалося завантажити зображення: %1").arg(filename));
            return;
        }
        
#ifdef DODEBUG
        QFile f(filename);
        qDebug() << "Exists:" << f.exists() << "Size:" << f.size();
#endif
        x1.blockSignals(true);
        y1.blockSignals(true);
        x2.blockSignals(true);
        y2.blockSignals(true);
        
        x1.setMaximum(rgbImage.width());
        x2.setMaximum(rgbImage.width());
        y1.setMaximum(rgbImage.height());
        y2.setMaximum(rgbImage.height());
        
        x2.setValue(rgbImage.width());
        y2.setValue(rgbImage.height());
				
        x1.blockSignals(false);
        y1.blockSignals(false);
        x2.blockSignals(false);
        y2.blockSignals(false);
        
        calcthreadsandprocess();
				resizeEvent(nullptr);
    }
}
void MainWindow::savefile(){
		QString filename = QFileDialog::getSaveFileName(this, tr("Save Image"), QDir::homePath(),
																										tr("Images (*.png *.jpg *.jpeg *.bmp *.webp *.jxl *.tiff)"));
		if (!filename.isEmpty()) {
				hsvImage.save(filename);
		}
}
bool MainWindow::eventFilter(QObject *obj, QEvent *event) {
    if (event->type() == QEvent::MouseButtonPress) {
        QPoint pos = static_cast<QMouseEvent*>(event)->pos();

        unsigned short imgX = pos.x() * hsvImage.width() / label.width();
        unsigned short imgY = pos.y() * hsvImage.height() / label.height();
            QColor color = hsvImage.pixelColor(imgX, imgY);
            float h, s, v;
            color.getHsvF(&h, &s, &v);
            QMessageBox::information(this, "Інформація про піксель",
																		 QString("%1, %2: RGB(%3, %4, %5), HSV(%6°, %7%, %8%)")
																		 .arg(imgX).arg(imgY)
																		 .arg(color.red()).arg(color.green()).arg(color.blue())
																		 .arg(h*360,0,'f',1).arg(s*100,0,'f',1).arg(v*100,0,'f',1));
        return true;
    }
    return QMainWindow::eventFilter(obj, event);
}

void MainWindow::calcthreadsandprocess(){
	height = y2.value() - y1.value();
	unsigned char roundmin = highestPowerOfTwo(QThread::idealThreadCount());
	numThreads = height/(height&-height);
	if (numThreads<QThread::idealThreadCount()){
#ifdef DODEBUG
			qDebug() << "Low threads detecred!";
#endif
			if(height>roundmin-1)
			numThreads = (height * roundmin == 0) ? 0 : (1 << static_cast<int>(std::__bit_width(height * roundmin) - 1)) / 64;
			else
		numThreads = height;
		}
	blockSize = height/numThreads;
#ifdef DODEBUG
    qDebug() << "Threads:" << numThreads;
#endif
		//QThreadPool::globalInstance()->setMaxThreadCount(numThreads);
    processimage();
}
